LasttextMember
	var/mob/m
	var/t

Bot
	var
		sensitivity=90
		savefile/database
		locked=0
		list/lasttext
		botname

	New(bname,dbase,s=90,l=0)
		..()
		botname=bname
		database=new /savefile(dbase)
		sensitivity=s
		locked=l

	proc
		InLasttext(t)
			for(var/LasttextMember/l in lasttext)
				if(l.m==t)
					return l

		GetReply(t) //Returns a reply for the string 't'. Returns -1 if nothing matching that phrase was found in the database
			var/list/plist
			for(var/a in database.dir) if(CompText(a,t)>=sensitivity) plist+=a
			var/t2
			if(length(plist))
				var/r=pick(plist)
				t2=pick(database[r])
				return t2
			return -1

		NoKnownReply(t,mob/m) //Called when the bot has no reply to 't', when 'm' uses that in a conversation with it. By default, only called by the Talk() proc.
			return

		SetSensitivity(n) //Sets the bot's sensitivity to 'n'
			sensitivity=n

		SetDatabase(f) //Sets the bot's database to 'f'
			database=new(f)

		SetBotname(t) //Sets the bot's name to 't'
			botname=t

		AddReply(t,r) //Adds the reply 'r' to the phrase 't'. Returns 1 if successful, 0 if unsuccessful (i.e., because the bot has been locked)
			var/list/l
			database[t] >> l
			if(l) l.Add(r)
			else l=list(r)
			if(!locked)
				database[t] << l
				return 1
			else
				return 0

		Lock() //Locks the bot's database so it will gain no new entries
			locked=1

		Unlock() //Unlocks the bot's database, so it can gain new entries
			locked=0

		Talk(t,mob/m)
			var/LasttextMember/L=InLasttext(m)
			if(L) if(L.t!=t) AddReply(StripText(L.t),t)
			var/r=GetReply(t)
			if(r==-1) NoKnownReply(t,m)
			else
				m << "[botname] says, \"[r]\""
				if(!L)
					var/LasttextMember/k= new/LasttextMember()
					k.m=m
					L=k
				L.t=r

proc
	StripText(var/a)
		return ckey(a)

	CompText(var/a,var/b)
		a=lowertext(ckey(a))
		b=lowertext(ckey(b))
		var/hits
		var/total
		if(length(a)>=length(b))
			total=length(a)
			for(var/c=1,c<=length(a),c++)
				if(c>length(b)) continue
				if(copytext(a,c,c+1)==copytext(b,c,c+1)) hits+=1
		else
			total=length(b)
			for(var/c=1,c<=length(b),c++)
				if(c>length(a)) continue
				if(copytext(a,c,c+1)==copytext(b,c,c+1)) hits+=1
		return (hits/total)*100